//+------------------------------------------------------------------+
//|                         MTF         Relative Vigor Index.mq4  ik |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                  /www.forex-tsd.com   http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Green
#property  indicator_color2  Red
//---- indicator parameters
extern int TimeFrame=0;
extern int ExtRVIPeriod=10;
//---- indicator buffers

double     ExtRVIBuffer[];
double     ExtRVISignalBuffer[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
 //---- indicator line
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtRVIBuffer);
   SetIndexBuffer(1,ExtRVISignalBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
//---- drawing settings   
   SetIndexDrawBegin(0,ExtRVIPeriod+3);   
   SetIndexDrawBegin(1,ExtRVIPeriod+7);     
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MTF_RVI("+ExtRVIPeriod+")");
   SetIndexLabel(0,"MTF RVI("+ExtRVIPeriod+")tf"+TimeFrame+"");
   SetIndexLabel(1,"MTF RVIs("+ExtRVIPeriod+")tf"+TimeFrame+"");
  
  
  
   
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   IndicatorShortName("MTF_RVI"+TimeFrame+"");  
  }
//----
   return(0); 

//+------------------------------------------------------------------+
//| On Balance Volume                                                |
//+------------------------------------------------------------------+

int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  
     
   ExtRVIBuffer[i]=iRVI(NULL,TimeFrame, ExtRVIPeriod,0,y);
   ExtRVISignalBuffer[i]=iRVI(NULL,TimeFrame, ExtRVIPeriod,1,y);
     
   }  
     
//
    
  
   return(0);
  }
//+-----+------------------------------------------------------------------+